-- eval.e test code

include wildcard.e  --upper()
include eval.e

constant WHITESPACE = "\n\t\r "

object ufo
sequence exp

-------------------------------------------------------------------------
-- Display functions
-------------------------------------------------------------------------

function printable_string( object s )
   --a string containing only characters between 32 and 255?
   if sequence( s ) then
      for c = 1 to length( s ) do
	 if integer( s[c] ) then
	    if (s[c] < 32) or (s[c] > 255) then
	       return( 0 )
	    end if
	 else
	    return( 0 )
	 end if
      end for
      return( 1 )
   end if
   return( 0 )
end function

function p_binary( integer i )
   --turns i into a string of binary digits
   sequence sx, sb
   sx = sprintf( "%x", { i } )
   sb = ""
   for c = 1 to length( sx ) do
      if sx[c] = '0' then
	 sb = sb & "0000"
      elsif sx[c] = '1' then
	 sb = sb & "0001"
      elsif sx[c] = '2' then
	 sb = sb & "0010"
      elsif sx[c] = '3' then
	 sb = sb & "0011"
      elsif sx[c] = '4' then
	 sb = sb & "0100"
      elsif sx[c] = '5' then
	 sb = sb & "0101"
      elsif sx[c] = '6' then
	 sb = sb & "0110"
      elsif sx[c] = '7' then
	 sb = sb & "0111"
      elsif sx[c] = '8' then
	 sb = sb & "1000"
      elsif sx[c] = '9' then
	 sb = sb & "1001"
      elsif sx[c] = 'A' then
	 sb = sb & "1010"
      elsif sx[c] = 'B' then
	 sb = sb & "1011"
      elsif sx[c] = 'C' then
	 sb = sb & "1100"
      elsif sx[c] = 'D' then
	 sb = sb & "1101"
      elsif sx[c] = 'E' then
	 sb = sb & "1110"
      elsif sx[c] = 'F' then
	 sb = sb & "1111"
      end if
   end for

   return( sb )
end function

-------------------------------------------------------------------------
-- Main test
-------------------------------------------------------------------------
puts( 1, "eval.e\n------\n" )
puts( 1, "Enter an expression to evaluate, 'exit' to quit.\n" )
while 1 do
   puts( 1, "\nExpression: " )
   ufo = gets( 0 )
   puts( 1, "\n" )
   ufo = ufo[1..length( ufo ) - 1]
   if not compare( upper( ufo ), "EXIT" ) then
      exit
   end if
   ufo = eval( ufo )
   if ufo[1] = EVAL_SUCCESS then
      puts( 1, "The answer is: " )
      ? ufo[2][1]
      if printable_string( ufo[2][1] ) then
	 puts( 1, "               \"" & ufo[2][1] & "\"\n" )
      elsif integer( ufo[2][1] ) then
	 printf( 1, "               #%x\n", { ufo[2][1] } )
	 puts( 1,   "               " & p_binary( ufo[2][1] ) & "b\n" )
	 if ufo[2][1] > 0 and ufo[2][1] <= 255 then
	    if not find( ufo[2][1], WHITESPACE ) then
	       puts( 1, "               '" & ufo[2][1] & "'\n" )
	    end if
	 end if
      end if
   else
      puts( 1, ufo[2] & "\n" )
   end if
end while


abort( 0 )

-------------------------------------------------------------------------
-- Speed test
-------------------------------------------------------------------------

exp = "(3 + 4) * 2 - 11 / ( 47 % 12 )"

constant reps = 10000
object p
atom t0, loop_overhead

t0 = time()
for i = 1 to reps do
end for
loop_overhead = time() - t0

puts( 1, "\nSpeed Test:\n" )
puts( 1,   " eval( \"" & exp & "\" )\n" )
printf( 1, " iterating %d times, please wait...\n", {reps} )
t0 = time()
for i = 1 to reps do
   p = eval( exp )
end for
printf( 1, " time: %f seconds per iteration (%d iterations)",  { (time() - t0 - loop_overhead)/reps, reps } )

abort( 0 )

-------------------------------------------------------------------------
-- Tests used during creation
-------------------------------------------------------------------------

--exp = " \"Fred \" & \"Barney \" "
--exp = " 'a' & 'b' & 'c' "
--exp = " (3 + 4) + 5 - 6 "
--exp = " #100 & 100000000b "
--exp = "\"ABC\" && #FF"
--exp = "{1, 2, 3} + {1, 2, 3}"
--exp = "{ 1 + 1, 2 + 2, 3 + 3 }"
exp = "{1, { 2, 4 }, 3} + {1, { 2, 4 }, 3}"
--exp = "( 2 * (3 + 4) )"
--exp = "-1 * { 1 + -1, 2 + 2, 3 + 3 } & { 2, 3 }"
--exp = "1000b+Fh&&12"
--exp = "$4 ` q"  --should error
--exp = "0.000659 * 6"

ufo = eval( exp )

puts( 1, "Expression: " & exp & "\n" )
if ufo[1] = EVAL_SUCCESS then
   puts( 1, "The answer is: " )
   ? ufo[2]
else
   puts( 1, ufo[2] & "\n" )
end if

